import gzip, os, poser
import cStringIO, base64
import wx, wx.py, wx.aui
man = poser.WxAuiManager()
root = man.GetManagedWindow()

scene = poser.Scene()

# ***** BEGIN GPL LICENSE BLOCK *****
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# ***** END GPL LICENCE BLOCK *****

"""
INSTRUCTIONS FOR USE
"""

def load_cr2(pathDonor,pathPose,pathBones="",remove_files=0,write_to_temp=0,remove_JCM=1,remove_JSM=1,remove_mags=1):
    if float(poser.Version()) < 9.0:
        print "This script requires Poser version 9 or greater."
        return
    if (not os.path.exists(pathDonor)) or (pathPose != "" and not os.path.exists(pathPose)) or (pathBones != "" and not os.path.exists(pathBones)):
        print "One or more submitted paths is invalid.  Please try again."
        return

    pmd_use = 0
    if poser.WriteBinaryMorphs(): # Always make sure pmd use is deactivated, for script run.
        pmd_use = 1
        app.status_update("Deactivating external binary morphs....")
        poser.SetWriteBinaryMorphs(0)
        
    app.status_update("Starting weight injection....")
    
    if write_to_temp:
        poser_temp = poser.TempLocation()
        basename = os.path.basename(pathDonor)
        pathDonor_temp = os.path.normpath(os.path.join(poser_temp,basename))
        pathDonor_temp = "%s_weighted%s" %(os.path.splitext(pathDonor_temp)[0],os.path.splitext(pathDonor_temp)[1])
    else:
        pathDonor_temp = "%s_weighted%s" %(os.path.splitext(pathDonor)[0],os.path.splitext(pathDonor)[1])
    pathDonor_temp = protect_naming(pathDonor_temp)
    

    if pathPose != "":
        app.status_update("Checking for settings file....")
        rules = read_datafile(pathPose,pathDonor)
    else:
        intnames = []
        affectors = []
        app.status_update("Checking for settings file....")
        rules = read_datafile(pathBones,pathDonor)
        
    if not rules:
        keep_specific = []
        keep_general = []
        use_proxy = 0
    else:
        if rules.has_key("magnet_preserve_specific"):
            keep_specific = [i for i in rules["magnet_preserve_specific"]]
            del rules["magnet_preserve_specific"]
        else:
            keep_specific = []
        if rules.has_key("magnet_preserve_general"):
            keep_general = [i for i in rules["magnet_preserve_general"]]            
            del rules["magnet_preserve_general"]
        else:
            keep_general = []
        if rules.has_key("use_proxy_scene"):
            if rules["use_proxy_scene"]:
                use_proxy = int(rules["use_proxy_scene"][0])
                del rules["use_proxy_scene"]
                if use_proxy:
                    temp_scene = proxy_scene()
                    if (not temp_scene) or (not os.path.exists(temp_scene)):
                        use_proxy = 0
            else:
                use_proxy = 0
        else:
            use_proxy = 0

    if use_proxy:
        app.status_update("Loading proxy scene....")
        poser.OpenDocument(temp_scene)        
        scene.ProcessSomeEvents(1)
        scene.DrawAll()

    app.status_update("Loading figure....")
    scene.LoadLibraryFigure(pathDonor) # Load donor .cr2 (to load any readScript morphs, as are used in V4)

    scene.ProcessSomeEvents(1)
    scene.DrawAll()   

    if pathPose != "":
        intnames = [act.InternalName() for act in scene.CurrentFigure().Actors() if act.IsBodyPart() and act.Geometry()]
        intnames = [i.split(":")[0] for i in intnames]
        app.status_update("Reading weight pose....")
        intnames, affectors, smooths = pose_reader(pathPose, intnames) # Get actor names from injection pose.  These will be processed for JCM removal

        if not intnames: # Bug crash if helper bones pose and weight pose are reversed; script should recognize situation and quit.
            app.status_update("Specified weight injection pose contains no weight maps!")
            return
        
        if intnames[0].find(":") != -1:
            pose_fignum = intnames[0].split(":")[1]
        for act in scene.CurrentFigure().Actors():        
            if act.IsBodyPart():
                fig_fignum = act.InternalName().split(":")[1]
                break
        for i in range(len(intnames)):
            line = intnames[i]
            if line.find(":") != -1:
                intnames[i] = line.replace(":%s" %(pose_fignum),":%s" %(fig_fignum))
            else:
                intnames[i] = "%s:%s" %(line,fig_fignum)    
                
    if remove_mags:
        excludes = []
        for act in scene.CurrentFigure().Actors():
            if act.IsBodyPart():            
                if not act.InternalName() in intnames:
                    if not act.InternalName() in excludes:
                        excludes.append(act.InternalName())
        
        app.status_update("Removing magnets....")
        deleteMags(scene.CurrentFigure(),excludes,keep_specific=keep_specific,keep_general=keep_general) # Delete figure magnets

    scene.ProcessSomeEvents(1)
    scene.DrawAll()

    app.status_update("Saving figure to library....")
    scene.SaveLibraryFigure(pathDonor_temp) # Save figure back to library under a new name; this cr2 will be edited and loaded by the loader cr2
    app.status_update("Removing figure from scene....")
    scene.DeleteCurrentFigure() # Delete this temporary figure

    if not os.path.exists(pathDonor_temp):
        print "Poser was unable to save the figure back to Libraries:Characters."
        print "Please check your settings and permissions and try again."
        return    
    
    if use_proxy > 1:
        app.status_update("Reverting proxy scene....")        
        poser.RevertDocument()        
        
    scene.ProcessSomeEvents(1)
    scene.DrawAll()    
    
    fig = figure()
    if pathPose != "": # Using weight injection
        app.status_update("Trimming saved cr2....")    
        merger(pathDonor_temp,fig,useWeights=0,useJoints=0,useAffects=1,remove_JCM=remove_JCM,remove_JSM=remove_JSM,affectors=affectors,smooths=smooths,
               replace_fignum=0,intnames=intnames,rules=rules,addBlock=0)

        if pathBones:
            app.status_update("Loading additional actors from pose....")
            merger(pathBones,fig,useWeights=0,useJoints=0,useAffects=0,remove_JCM=0,remove_JSM=0,affectors=None,smooths=None,
                   replace_fignum=1,intnames=None,rules=None,addBlock=0)
        
        app.status_update("Merging weight injection data into figure....")
        merger(pathPose,fig,useWeights=1,useJoints=1,useAffects=1,remove_JCM=remove_JCM,remove_JSM=remove_JSM,affectors=None,smooths=None,
               replace_fignum=1,intnames=None,rules=None,addBlock=1)
        
    else: # Just using extra actors pose to insert new actors, geometry references, and/or parameters
        app.status_update("Processing saved cr2....")
        merger(pathDonor_temp,fig,useWeights=1,useJoints=1,useAffects=1,remove_JCM=0,remove_JSM=0,affectors=None,smooths=None,
               replace_fignum=0,intnames=None,rules=rules,addBlock=0)

        app.status_update("Loading additional actors from pose....")
        merger(pathBones,fig,useWeights=0,useJoints=0,useAffects=0,remove_JCM=0,remove_JSM=0,affectors=None,smooths=None,
               replace_fignum=1,intnames=None,rules=None,addBlock=0)
        
    remove_groups(fig,rules)

    app.status_update("Path = %s" %(pathDonor_temp))
    writer(pathDonor_temp,fig)

    if not os.path.exists(pathDonor_temp):
        print "There was an error writing the edited cr2 to the selected location."
        print "Please check your settings and permissions and try again."
        return

    app.status_update("Loading new figure....")
    scene.LoadLibraryFigure(pathDonor_temp) # Load the weight injection pose loader .cr2.  This will load the figure and apply the weights.      

    app.status_update("Removing temp files....")
    if remove_files:
        os.remove(pathDonor_temp) # Delete cr2 saved back to library.
        pathLibThumb = "%s.png" %(os.path.splitext(pathDonor_temp)[0]) # Bug reported by Amigo968
        if os.path.exists(pathLibThumb):
            os.remove(pathLibThumb) # Delete library save .png file.
        else:
            app.status_update("No .png found for temporary .cr2.  Skipping .png deletion.")

    if pmd_use:
        app.status_update("Reactivating external binary morphs....")
        poser.SetWriteBinaryMorphs(1)
        
    if use_proxy:
        os.remove(temp_scene)
    excludes = intnames = affectors = []
    app.status_update("Done!")

    scene.ProcessSomeEvents(1)
    scene.DrawAll()

def read_datafile(pathPose,pathDonor):
    """
    applicatorSetting=targetGeom_delete
    applicatorSetting=targetGeom_preserve
    applicatorSetting=valueParm_delete
    applicatorSetting=valueParm_preserve
    applicatorSetting=magnet_preserve_specific
    applicatorSetting=magnet_preserve_general
    applicatorSetting=figname_append
    applicatorSetting=figname_replace
    applicatorSetting=targetGeom_zero_deltas
    applicatorSetting=use_proxy_scene
    applicatorSetting=groups_remove
    """
    path = os.path.normpath(os.path.splitext(pathPose)[0].replace("_weight_pose","_settings.txt"))    
    if not os.path.exists(path): # Check weight pose location
        path = os.path.normpath( os.path.splitext(os.path.join(os.path.dirname(poser.ScriptLocation()),os.path.basename(pathPose)))[0].replace("_weight_pose","_settings.txt") )        
        if not os.path.exists(path): # Check script location
            dirname = os.path.dirname(pathDonor)
            name = os.path.splitext(os.path.basename(pathPose))[0].replace("_weight_pose","_settings.txt")
            path = os.path.normpath(os.path.join(dirname,name))            
            if not os.path.exists(path): # Check target cr2 location
                app.status_update("No data file found for this pose.")
                return None
    app.status_update("Found data file:")
    app.status_update(path)    
    f = open(path, "r")
    g = f.readlines()
    f.close()

    setting = ""
    rules = {}    
    for line in g:
        ls = line.strip()
        if not ls:
            continue
        if ls.find("applicatorSetting=") != -1:
            setting = ls.replace("applicatorSetting=","")
            rules[setting] = []
        else:
            if rules.has_key(setting):
                rules[setting].append(ls)
    g = []
    return rules

def remove_groups(fig,rules):
    """
    """
    if not "groups_remove" in rules.keys():
        return
    remove = {}
    for i in rules["groups_remove"]:
        k,v = i.split("<:>")
        if not k in remove:
            remove[k] = [v]
        else:
            remove[k].append(v)
    for act in fig.parmAct:
        intname = act.intname.split(":")[0]
        if intname in remove.keys():
            groups = []
            node = 0
            for line in act.chans.groups:
                if node:
                    if line.find("}") != -1:
                        node = 0
                    continue
                if line.find("groupNode") != -1:
                    lt = line.strip().replace("\t"," ").replace("groupNode ","")
                    if lt:
                        if lt in remove[intname]:
                            node = 1
                            continue
                groups.append(line)
            act.chans.groups = [i for i in groups]            

def pose_reader(pathPose,intnames):
    """
    """    
    path,ext = os.path.splitext(pathPose)
    if ext == ".p2z" or ext == ".P2Z":
        f = gzip.GzipFile(pathPose)
    else:
        f = open(pathPose,"r")
    g = f.readlines()
    f.close()    
    acts = []    
    affectors = []
    smooths = []
    fignum = ""
    intname = ""    
    for num,line in enumerate(g):
        lt = line.strip().split()
        if not lt:
            continue
        if lt[0] == "actor":
            checkline = g[num+1].strip().split()
            if checkline and (not checkline[0] == "storageOffset") and (not checkline[0] == "geomCustom") and\
                   (not checkline[0] == "}"):
                checknum = line.replace("\n","").replace("\r","").split(":")[1]
                if checknum: # Rare case involving a figure freshly-created using the .phi process, or a hacked .cr2, will lack a figure number                    
                    if not fignum:
                        fignum = checknum
                    if checknum != fignum:
                        continue
                intname = line.strip().replace("actor ","")               
                num2 = 0
                while 1:
                    num2 += 1
                    lt2 = g[num+num2].strip().split()
                    if not lt2:
                        continue
                    if lt2[0] == "actor" or lt2[0] == "channels":                                                   
                        break
                    elif lt2[0] == "weightMap":                        
                        if not intname in acts:
                            acts.append(intname)                            
                        break
                    elif g[num+num2].replace("\n","").replace("\r","") == "\t}": # End of actor block reached
                        break
        elif (intname != "") and (not intname.split(":")[0] in intnames):            
            continue
        
        elif ((lt[0][:-1] == "twist") or (lt[0][:-1] == "joint")):                        
            if (lt[1][:-1] != "twist") and (lt[1][:-1] != "joint"):                
                num2 = 1
                nextline = g[num+num2]
                stopline = nextline.replace("{","}")
                otherAct = ""
                while nextline != stopline:
                    nextline = g[num+num2]
                    nextlt = nextline.strip().split()
                    if nextlt[0] == "otherActor":
                        otherAct = nextline.strip().replace("\t"," ").replace("otherActor ","")
                        break
                    num2 += 1
                if otherAct:
                    name = otherAct.split(":")[0]
                    if not name in affectors:
                        affectors.append(name)
        elif lt[0][:-1] == "smoothScale":
            num2 = 1
            nextline = g[num+num2]
            stopline = nextline.replace("{","}")
            otherAct = ""
            while nextline != stopline:
                nextline = g[num+num2]
                nextlt = nextline.strip().split()
                if nextlt[0] == "otherActor":
                    otherAct = nextline.strip().replace("\t"," ").replace("otherActor ","")
                    break
                num2 += 1
            if otherAct:
                name = otherAct.split(":")[0]
                if not name in smooths:
                    smooths.append(name)
                 
    g = []    
    return acts, affectors, smooths 

def check_gzip(dataPath):
    """
    Determine whether a file is gzipped, by checking for its 'magic number'.
    """
    f = open(dataPath,"rb")
    magic = f.read(2)    
    f.close()
    if magic == '\037\213': return 1
    else: return 0

class figure(object):
    """
    """
    def __init__(self):
        self.version = "version\n\t{\n\tnumber 9\n\t}\n"
        self.fignum = ""
        self.figRes = ""
        self.geomAct = {}
        self.geomProp = []
        self.parmAct = []
        self.actnames = []
        self.parmProp = []
        self.figTop = []
        self.figAdd = []
        self.figMid = []
        self.figWeld = []
        self.figBottom = []
        self.footer = []

    def check_fignum(self,actline):
        checknum = actline.replace("\n","").split(":")[1]        
        if not checknum:
            return 0
        if not self.fignum:
            self.fignum = checknum
            return 1
        if checknum != self.fignum:            
            return 0
        else:
            return 1   

class actor(object):
    """
    """
    def __init__(self):
        self.intname = ""
        self.name = ""
        self.animO = ""
        self.top = []
        self.weights = []
        self.chans = None
        self.origin = ""
        self.endpoint = ""
        self.orientation = ""
        self.bottom = []

class channels(object):
    """
    """
    def __init__(self):
        self.open = ["\tchannels\n","\t\t{\n"]
        self.close = "\t\t}\n"
        self.groups = []
        self.top = []
        self.affects = []
        self.mid = []
        self.offA = []
        self.joints = []
        self.bottom = []


def writer(pathFile,fig):
    """    
    """
    f = open(pathFile,"w")
    f.write("{\n")
    f.write(fig.version)
    f.write(fig.figRes)    
    for act in fig.actnames:
        if not act in fig.geomAct.keys():
            # PRINT an explanation of error message which will be printed by this situation --> DO NOT PORT THIS TO STATUS BOX
            # Error is caused by incorrect submitted pose paths
            print "Actor %s has no geometry listing.  Please verify that the supplied pose paths are correct, then re-run the script." %(act)
        for line in fig.geomAct[act]: # Bug reported by Robynsveil for SunFire
            f.write(line)
    for line in fig.geomProp:
        f.write(line)
    f.write(fig.figRes)    
    for act in fig.parmAct:        
        f.write("actor %s\n\t{\n" %(act.intname))
        for line in act.top:
            if line.find("animatableOrigin") != -1:
                #f.write("\tanimatableOrigin %s\n" %(act.animO))
                f.write(act.animO) # Added 2/4/12
            else:
                f.write(line)
        for line in act.weights:
            f.write(line)
        for line in act.chans.open:
            f.write(line)
        for line in act.chans.groups:
            f.write(line)
        for line in act.chans.top:            
            f.write(line)
        for line in act.chans.affects:
            f.write(line)
        for line in act.chans.offA:
            f.write(line)
        for line in act.chans.mid:
            f.write(line)
        for line in act.chans.joints:
            f.write(line)
        for line in act.chans.bottom:
            f.write(line)
        f.write(act.chans.close)
        f.write(act.endpoint)
        f.write(act.origin)
        f.write(act.orientation)
        for line in act.bottom:
            f.write(line)
    for line in fig.parmProp:
        f.write(line)
    for line in fig.figTop:
        f.write(line)
    for line in fig.figAdd:
        f.write(line)
    for line in fig.figMid:
        f.write(line)
    for line in fig.figWeld:
        f.write(line)
    for line in fig.figBottom:
        f.write(line)
    for line in fig.footer:
        f.write(line)
    f.close()

def merger(pathFile,fig,useWeights=0,useJoints=0,useAffects=0,remove_JCM=1,remove_JSM=1,affectors=None,smooths=None,replace_fignum=0,intnames=None,
           rules=None,addBlock=0,useUnknown=1,bonescreen=None):    
    check = check_gzip(pathFile) # If Poser is set to save compressed files, it will have saved as .crz even if a .cr2 extension was given in the save path
    if check:
        f = gzip.GzipFile(pathFile)
    else:
        f = open(pathFile,"r")
    g = f.readlines()
    f.close()
        
    if replace_fignum: # Replace all figure number references in poses to make them consistent with cr2.
        num = "-1"
        for i in range(len(g)):
            line = g[i].replace("\r","\n")
            lt = line.strip().split()
            if num == "-1":
                if lt[0] == "actor":
                    if line.find(":") != -1:
                        num = lt[len(lt)-1].split(":")[1]                        
            if line.find(":%s" %(num)) != -1:
                g[i] = line.replace(":%s" %(num),":%s" %(fig.fignum))                
            elif lt[0] == "Figure" and line.find(num) != -1:
                g[i] = line.replace(num,fig.fignum)

    if not rules:
        rules = {}
    rules_keys = ["targetGeom_delete","targetGeom_preserve","valueParm_delete","valueParm_preserve","figname_append","figname_replace",
                  "targetGeom_zero_deltas","use_proxy_scene","groups_remove"]
    for rule in rules_keys:
        if not rule in rules.keys():
            rules[rule] = []
            
    depth = 0
    prevline = ""
    
    newact = None
    newchans = None
    
    actdepth = 2
    channeldepth = 3
    parmdepth = 4    

    ischannels = 0
    isfigure = 0
    blockType = ""    
    proptypes = ["prop","baseProp","magnetDeformerProp","sphereZoneProp","hairProp","waveDeformerProp"]
    injecting = 0
    inject_fig = 0
    not_in_pose = 0
    intname = ""
    bone_intname = ""
    remove_deltas = 0
    #blank_geom = 0
    
    for num,line in enumerate(g):
        line = line.replace("\r","\n")
        numtabs = line.count("\t")
        ls = line.strip()
        lt = ls.split()        
        if not lt:
            continue
        if addBlock == 1:
            if lt[0] == "actor":
                intname = "%s:%s" %(line.strip().replace("actor ","").split(":")[0],fig.fignum)                
            if (intname != "") and (not intname in fig.actnames):            
                continue
        if bonescreen != None and num < len(g)-1: # Bonescreen handling added for garment conversion 
            if g[num+1].strip().split() == "actor":
                bone_intname = line.strip().replace("actor ","").split(":")[0]
            if g[num+1].strip().split() == "figure":
                bone_intname = ""                
            if (bone_intname != "") and (bone_intname in bonescreen):
                continue
        # Handle opening brackets
        if lt[0] == "{":
            depth += 1            
            prev_lt = prevline.strip().replace("\t"," ").split()
            if not prev_lt:
                continue
            if prev_lt[0] == "actor":
                good = fig.check_fignum(prevline) # Limit processing to only the first figure in the .cr2
                if not good:                    
                    continue
                checkline = g[num+1].strip().split()
                if checkline and (not checkline[0] == "storageOffset") and (not checkline[0] == "geomCustom") and\
                   (not checkline[0] == "}"): # Separate handling for actor geom listings and parm listings
                    intname = "%s:%s" %(prevline.strip().replace("actor ","").split(":")[0],fig.fignum)                    
                    if (addBlock == 1) and (intname != "") and (not intname in fig.actnames):                        
                        continue
                    not_in_pose = 0
                    if intnames:
                        if not intname in intnames:
                            not_in_pose = 1
                    if (bonescreen != None) and (intname != "") and (intname.split(":")[0] in bonescreen):
                        continue                        
                    if intname in fig.actnames:                        
                        newact = fig.parmAct[fig.actnames.index(intname)] # If the actor has already been initialized, inject new elements into it
                        injecting = 1
                        if "\t\t}\n" in newact.chans.bottom: # Added 2/4/12
                            newact.chans.bottom.remove("\t\t}\n")
                    else:
                        newact = actor()
                        newact.intname = intname
                        fig.actnames.append(newact.intname)
                        injecting = 0                        
                else:
                    #blank_geom = 0
                    intname = "%s:%s" %(prevline.strip().replace("actor ","").split(":")[0],fig.fignum)                    
                    if (addBlock == 1) and (intname != "") and (not intname in fig.actnames):                       
                        continue
                    if (bonescreen != None) and (intname != "") and (intname.split(":")[0] in bonescreen):
                        continue
                    blockType = "geomAct"                    
                    fig.geomAct[intname] = [prevline] # This is on the figure level, so geometry injection works without calling up the actor class instance
                    #if (not checkline) or (checkline == "}"): # Correct for empty geometry
                        #blank_geom = 1
            elif prev_lt[0] in proptypes:
                good = fig.check_fignum(prevline) # Limit processing to only the first figure in the .cr2
                if not good:                    
                    continue
                checkline = g[num+1].strip().split()
                if checkline and ((checkline[0] == "storageOffset") or (checkline[0] == "geomCustom")):
                    blockType = "geomProp"
                    fig.geomProp.append(prevline)
                else:
                    blockType = "parmProp"
                    fig.parmProp.append(prevline)

            elif prev_lt[0] == "figure":
                if not fig.figTop:
                    blockType = "figTop"
                    fig.figTop.append(prevline)
                    inject_fig = 0                    
                else:
                    inject_fig = 1 # If figure section has already been filled, inject new elements to avoid duplicating lines common to both files
                isfigure = 1               

            elif prev_lt[0] == "hairGrowthGroup":
                blockType = "footer"
                fig.footer.append(prevline)

            elif prev_lt[0] == "clothSimulator":
                blockType == "footer"
                fig.footer.append(prevline)
                
                    
            if (depth > actdepth) and (newact != None): # An actor's parameter block has been found.                    
                if prev_lt[0] == "weightMap":                    
                    if useWeights or not_in_pose:                        
                        blockType = "weights"
                        newact.weights.append(prevline) # Handle weightMap section as solid block
                                            
                if prev_lt[0] == "channels":
                    ischannels = 1                    
                    if not injecting:                        
                        newchans = channels()
                        #newchans.top.append(prevline)                        
                        #newchans.top.append(line)
                    else:
                        newchans = newact.chans
                    
                if ischannels and depth == parmdepth:
                    if prev_lt[0] == "groups":
                        blockType = "chansGroup"
                        if injecting:
                            newchans.groups = []
                        newchans.groups.append(prevline)
                        
                    elif prev_lt[0] == "targetGeom":
                        if not not_in_pose:
                            name = prevline.strip().replace("\t"," ").replace("targetGeom ","")                            
                            if not (name in rules["targetGeom_preserve"]):                                
                                remove_this = 0
                                for partialName in rules["targetGeom_delete"]:
                                    if name.find(partialName) != -1:
                                        remove_this = 1
                                        break
                                if remove_this:
                                    remove_deltas = 0
                                    for partialname in rules["targetGeom_zero_deltas"]:
                                        if partialname != "JCM" and partialname != "JSM":
                                            if name.find(partialName) != -1:
                                                remove_deltas = 1
                                                break
                                    if not remove_deltas:
                                        continue
                                if remove_JCM:
                                    if prevline.find("JCM") != -1:
                                        if not "JCM" in rules["targetGeom_zero_deltas"]:
                                            continue
                                        else:
                                            remove_deltas = 1
                                if remove_JSM:
                                    if prevline.find("JSM") != -1:
                                        if not "JSM" in rules["targetGeom_zero_deltas"]:
                                            continue
                                        else:
                                            remove_deltas = 1
                        blockType = "chansTop"
                        newchans.top.append(prevline)
                        
                    elif prev_lt[0] == "valueParm":                        
                        name = prevline.strip().replace("\t"," ").replace("valueParm ","")                        
                        if not name in rules["valueParm_preserve"]:
                            remove_this = 0
                            for partialName in rules["valueParm_delete"]:
                                if name.find(partialName) != -1:
                                    remove_this = 1
                                    break
                            if remove_this:                                
                                continue                            
                        blockType = "chansTop"
                        newchans.top.append(prevline)

                    elif prev_lt[0] == "deformerPropChan":
                        blockType = "chansTop"
                        newchans.top.append(prevline)

                    elif prev_lt[0][:-1] == "taper":
                        blockType = "chansTop"
                        newchans.top.append(prevline)
                        
                    elif prev_lt[0][:-1] == "smoothScale": # Include smoothScales with joint affector listings
                        if not_in_pose:
                            blockType = "affects"                                
                            newchans.affects.append(prevline)
                        else:
                            if useAffects:
                                if not smooths:                                
                                    blockType = "affects"                                
                                    newchans.affects.append(prevline) # Other actor joint affector listings
                                else:
                                    name = prev_lt[1].split("_")[0]                                
                                    if name in smooths: # Only remove otherActor references if they are also listed in the pose                                        
                                        continue
                                    else:                                        
                                        blockType = "affects"                                
                                        newchans.affects.append(prevline)
                        
                    elif ((prev_lt[0][:-1] == "twist") or (prev_lt[0][:-1] == "joint")):                        
                        if (prev_lt[1][:-1] == "twist") or (prev_lt[1][:-1] == "joint"):
                            if useJoints or not_in_pose:
                                blockType = "joints"                                
                                newchans.joints.append(prevline) # The actor's own joints
                        else:
                            if not_in_pose:
                                blockType = "affects"                                
                                newchans.affects.append(prevline)
                            else:
                                if useAffects:
                                    if not affectors:                                    
                                        blockType = "affects"                                
                                        newchans.affects.append(prevline) # Other actor joint affector listings
                                    else:
                                        name = prev_lt[1].split("_")[0]                                    
                                        if name in affectors: # Only remove otherActor references if they are also listed in the pose
                                            continue
                                        else:                                            
                                            blockType = "affects"                                
                                            newchans.affects.append(prevline)
                            
                    elif ((prev_lt[0] == "scale") or (prev_lt[0][:-1] == "scale") or\
                          (prev_lt[0] == "propagatingScale") or (prev_lt[0][:-1] == "propagatingScale")):                                                    
                        blockType = "chansMid"
                        newchans.mid.append(prevline)
                    
                    elif prev_lt[0][1:] == "OffsetA":                                              
                        newchans.offA.append(prevline)
                        blockType = "chansOffA"                        
                        
                    elif prev_lt[0][1:] == "OffsetB":                        
                        blockType = "chansBottom"                        
                        newchans.bottom.append(prevline)
                        
                    elif prev_lt[0][:-1] == "rotate":                        
                        blockType = "chansBottom"
                        newchans.bottom.append(prevline)
                        
                    elif prev_lt[0][:-1] == "translate":                        
                        blockType = "chansBottom"
                        newchans.bottom.append(prevline)
                        
                    elif prev_lt[0] == "geomChan":
                        blockType = "chansBottom"
                        newchans.bottom.append(prevline)
                        
                    else:
                        if useUnknown:
                            blockType = "chansBottom"
                            newchans.bottom.append(prevline)
                        else:
                            pass
                        
        # Handle closing brackets
        elif lt[0] == "}":
            depth -= 1
            if blockType == "joints" and depth < parmdepth:                
                newchans.joints.append(line)
                blockType = ""
            elif blockType == "affects" and depth < parmdepth:
                newchans.affects.append(line)
                blockType = ""
            elif blockType == "chansGroup" and depth < parmdepth:
                newchans.groups.append(line)
                blockType = ""
            elif blockType == "chansTop" and depth < parmdepth:                
                newchans.top.append(line)
                blockType = ""
                remove_deltas = 0
            elif blockType == "chansMid" and depth < parmdepth:
                newchans.mid.append(line)
                blockType = ""
            elif blockType == "chansOffA" and depth < parmdepth:
                newchans.offA.append(line)
                blockType = ""
            elif blockType == "chansBottom" and depth < parmdepth:
                newchans.bottom.append(line)                
                blockType = ""
                                 
            if blockType == "weights" and depth < channeldepth:                
                newact.weights.append(line)
                blockType = ""            
            elif blockType == "actBottom" and depth < actdepth:
                if not injecting: # Added 2/4/12
                    newact.bottom.append(line)
                else:
                    if not line in newact.bottom:
                        newact.bottom.append(line)
                blockType = ""
            if ischannels and depth < channeldepth:
                ischannels = 0
                #if not injecting:
                    #newchans.bottom.append(line)
                    #newact.chans = newchans
                #newchans.bottom.append(line) # Added 2/4/12
                newact.chans = newchans
                newchans = None                    
            if newact != None and depth < actdepth:
                if not injecting:
                    fig.parmAct.append(newact)
                newact = None                
            elif blockType == "parmProp" and depth < actdepth:
                fig.parmProp.append(line)
                blockType = ""
            elif blockType == "geomAct" and depth < actdepth:                
                fig.geomAct[intname].append(line)
                blockType = ""
            elif blockType == "geomProp" and depth < actdepth:                
                fig.geomProp.append(line)
                blockType = ""
            elif isfigure and depth < actdepth:
                isfigure = 0
                if not inject_fig:
                    fig.figBottom.append(line)
                blockType = ""
            elif blockType == "footer" and depth < actdepth:
                fig.footer.append(line)
                blockType = ""

        # Handle actor block variables        
        if depth == actdepth:
            if newact != None:
                if lt[0] == "name":                
                    newact.name = line
                    blockType = "actTop"
                elif lt[0]=="on" or lt[0] == "bend": # Added 2/4/12
                    blockType = "actTop"
                elif lt[0] == "animatableOrigin":
                    newact.animO = line
                    if injecting and lt[1] == "1":
                        newact.chans.offA = [] # Requires that ALL THREE OffsetA parameters be included in pose to activate animatable origins for that actor.
                    blockType = "actTop"
                elif lt[0] == "weightMap":
                    blockType = ""
                elif lt[0] == "channels":
                    if blockType == "actTop":
                        blockType = ""
                elif lt[0] == "endPoint":
                    newact.endpoint = line
                elif lt[0] == "origin":
                    newact.origin = line
                elif lt[0] == "orientation":
                    newact.orientation = line
                elif lt[0] == "displayOrigin":
                    blockType = "actBottom"                
            if isfigure:
                if lt[0] == "name":
                    if rules["figname_replace"]:
                        line = "%sname %s\n" %("\t"*actdepth,rules["figname_replace"][0])
                    elif rules["figname_append"]:
                        line = "%s%s%s\n" %("\t"*actdepth,line.replace("\n","").replace("\r",""),rules["figname_append"][0])
                if lt[0] == "root" or lt[0] == "addChild":                    
                    blockType = "figAdd"                    
                elif lt[0] == "inkyChain":
                    blockType = "figMid"
                elif lt[0] == "defaultPick":
                    blockType = "figMid"
                elif lt[0] == "weld":
                    blockType = "figWeld"
                elif lt[0] == "allowsBending" or lt[0] == "figureType":
                    blockType = "figBottom"
                elif lt[0] == "material":
                    blocktype = "figBottom"
                elif lt[0] == "displayOn":
                    blockType = "figBottom"
            
        elif depth < actdepth:
            if (not fig.figRes) and (lt[0] == "figureResFile"):
                fig.figRes = line
            if lt[0] == "setGeomHandlerOffset":
                blockType = "footer"               
            
        prevline = line # Store the previous line for reference when an opening bracket is found.
        
        if blockType == "joints":            
            newchans.joints.append(line)
        elif blockType == "affects":            
            newchans.affects.append(line)
        elif blockType == "weights":            
            newact.weights.append(line)
        elif blockType == "chansGroup":
            newchans.groups.append(prevline)
        elif blockType == "chansTop":
            if not remove_deltas:
                newchans.top.append(line)
            else:
                if lt[0] == "indexes":
                    line = "\t\t\tindexes 0\n"
                if lt[0] != "d":
                    newchans.top.append(line)
        elif blockType == "chansMid":
            newchans.mid.append(line)
        elif blockType == "chansOffA":
            newchans.offA.append(line)
        elif blockType == "chansBottom":
            newchans.bottom.append(line)
        elif blockType == "actTop":
            if not injecting: # Added 2/4/12
                newact.top.append(line)
            else:
                if not line in newact.top:
                    newact.top.append(line)
        elif blockType == "actBottom":
            if not injecting: # Added 2/4/12
                newact.bottom.append(line)
            else:
                if not line in newact.bottom:
                    newact.bottom.append(line)
        elif blockType == "parmProp":
            fig.parmProp.append(line)                            
        elif blockType == "geomAct":            
            fig.geomAct[intname].append(line)
            #if blank_geom:
                #fig.geomAct[intname].append("\tstorageOffset 0 0.3487 0\n")
                #fig.geomAct[intname].append("\tgeomHandlerGeom 13 %s\n" %(intname.split(":")[0]))
                #blank_geom = 0
        elif blockType == "geomProp":
            fig.geomProp.append(line)
        elif blockType == "figTop":
            if not inject_fig:
                fig.figTop.append(line)
        elif blockType == "figAdd":
            fig.figAdd.append(line)            
        elif blockType == "figMid":           
            fig.figMid.append(line)
        elif blockType == "figWeld":
            fig.figWeld.append(line)
        elif blockType == "figBottom":            
            fig.figBottom.append(line)
        elif blockType == "footer":
            fig.footer.append(line)

def deleteMags(fig,excludes,keep_specific=[],keep_general=[]):
    """
    """
    magnames = [a.InternalName() for a in fig.Actors() if a.IsDeformer()]    
    keepmags = []
    for name in keep_specific:
        keepmags.append(name)
    for name in magnames:
        for partialName in keep_general:        
            if not name in keepmags:
                if name.find(partialName) != -1:
                    keepmags.append(name)
    
    for actname in excludes:        
        act = fig.ActorByInternalName(actname)
        for parm in act.Parameters():
            if not parm.TypeCode() == poser.kParmCodeDEFORMERPROP:
                continue
            intname = parm.InternalName()
            if intname in magnames: # Assuming that deformer parm intname will match deformer intname.  May not always be true...?
                if not intname in keepmags:
                    keepmags.append(intname)    
    current_act = scene.CurrentActor()
    actors = [a for a in fig.Actors() if a.IsDeformer()]    
    for act in actors:        
        if not act.InternalName() in keepmags:            
            scene.SelectActor(act)
            scene.DeleteCurrentProp()
    scene.SelectActor(current_act)

def protect_naming(path):
    """Ensure unique file naming to avoid overwriting anything."""
    folder = os.path.dirname(path)
    filename = os.path.basename(path)    
    name,ext = os.path.splitext(filename)
    if os.path.exists(path):
        num = 0
        newname = "%s_%s%s" %(name,num,ext)
        while os.path.exists(os.path.join(folder,newname)):
            num += 1
            newname = "%s_%s%s" %(name,num,ext)
        return os.path.normpath(os.path.join(folder,newname))
    else:
        return path

def proxy_scene():
    scenelist = ['{\n', 'version\n', '\t{\n', '\tnumber 9\n', '\t}\n', 'prop GROUND\n', '\t{\n',
                 '\tstorageOffset 0 0 0\n', '\tobjFileGeom 0 0 :Runtime:Geometries:props:ground.obz\n',
                 '\t}\n', 'actor UNIVERSE\n', '\t{\n', '\t}\n', 'light spotLight 1\n', '\t{\n',
                 '\tstorageOffset 0 0 0\n', '\tobjFileGeom 0 0 :Runtime:Geometries:Lights:infLite.obj\n',
                 '\t}\n', 'prop GROUND\n', '\t{\n', '\tname    GROUND\n', '\toff\n', '\tbend 1\n',
                 '\tdynamicsLock  1\n', '\thidden  0\n', '\taddToMenu 1\n', '\tcastsShadow  1\n',
                 '\tincludeInDepthCue  0\n', '\tuseZBuffer  1\n', '\tparent UNIVERSE\n', '\tcreaseAngle 80\n',
                 '\tchannels\n', '\t\t{\n', '\t\trotateY yaw\n', '\t\t\t{\n', '\t\t\tname turn\n', '\t\t\tinitValue 0\n',
                 '\t\t\thidden 0\n', '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n',
                 '\t\t\ttrackingScale 1\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  0\n',
                 '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n',
                 '\t\t\t}\n', '\t\tpropagatingScale scale\n', '\t\t\t{\n', '\t\t\tname scale\n', '\t\t\tinitValue 4\n',
                 '\t\t\thidden 0\n', '\t\t\tforceLimits 0\n', '\t\t\tmin 0.001\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 0.004\n',
                 '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  4\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n',
                 '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\tpropagatingScaleX xScale\n',
                 '\t\t\t{\n', '\t\t\tname xScale\n', '\t\t\tinitValue 1\n', '\t\t\thidden 0\n', '\t\t\tforceLimits 0\n',
                 '\t\t\tmin 0.001\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 0.004\n', '\t\t\tkeys\n', '\t\t\t\t{\n',
                 '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  1\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n',
                 '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\tpropagatingScaleZ zScale\n', '\t\t\t{\n', '\t\t\tname zScale\n',
                 '\t\t\tinitValue 1\n', '\t\t\thidden 0\n', '\t\t\tforceLimits 0\n', '\t\t\tmin 0.001\n', '\t\t\tmax 100000\n',
                 '\t\t\ttrackingScale 0.004\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  1\n',
                 '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n',
                 '\t\ttranslateX dollyX\n', '\t\t\t{\n', '\t\t\tname dollyX\n', '\t\t\tinitValue 0\n', '\t\t\thidden 0\n',
                 '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 0.001\n',
                 '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  0\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n',
                 '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\ttrackingScaleMult 1\n', '\t\t\t}\n',
                 '\t\ttranslateZ dollyZ\n', '\t\t\t{\n', '\t\t\tname dollyZ\n', '\t\t\tinitValue 0\n', '\t\t\thidden 0\n',
                 '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 0.001\n', '\t\t\tkeys\n',
                 '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  0\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n',
                 '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\ttrackingScaleMult 1.000000\n', '\t\t\t}\n', '\t\ttranslateY dollyY\n',
                 '\t\t\t{\n', '\t\t\tname dollyY\n', '\t\t\tinitValue -0.001\n', '\t\t\thidden 1\n', '\t\t\tforceLimits 1\n', '\t\t\tmin -0.001\n',
                 '\t\t\tmax -0.001\n', '\t\t\ttrackingScale 0.002\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n',
                 '\t\t\t\tk  0  -0.001\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n',
                 '\t\t\ttrackingScaleMult 1.000000\n', '\t\t\t}\n', '\t\t}\n', '\tendPoint 0 1 0.6\n', '\torigin 0 0 0\n', '\torientation 0 0 0\n',
                 '\tdisplayOrigin  0\n', '\tdisplayMode HIDLINE\n', '\tcustomMaterial 1\n', '\tmaterial Preview\n', '\t\t{\n',
                 '\t\tKdColor 0.8 0.8 0.8 1\n', '\t\tKaColor 0 0 0 0\n', '\t\tKsColor 0.8 0.8 0.8 1\n', '\t\tTextureColor 1 1 1 1\n',
                 '\t\tNsExponent 10\n', '\t\ttMin 0\n', '\t\ttMax 0\n', '\t\ttExpo 0.6\n', '\t\tbumpStrength 0.0516\n', '\t\tksIgnoreTexture 0\n',
                 '\t\treflectThruLights 0\n', '\t\treflectThruKd 0\n', '\t\ttextureMap NO_MAP\n', '\t\tbumpMap NO_MAP\n', '\t\treflectionMap NO_MAP\n',
                 '\t\ttransparencyMap NO_MAP\n', '\t\tReflectionColor 1 1 1 1\n', '\t\treflectionStrength 0.2\n', '\t\t}\n', '\tlocked 0\n',
                 '\tbackfaceCull 0\n', '\tvisibleInReflections 1\n', '\tvisibleInRender 1\n', '\tvisibleInCamera 1\n', '\t}\n', 'actor UNIVERSE\n',
                 '\t{\n', '\tname    UNIVERSE\n', '\ton\n', '\tbend 1\n', '\tdynamicsLock  1\n', '\thidden  1\n', '\taddToMenu 0\n',
                 '\tcastsShadow  1\n', '\tincludeInDepthCue  0\n', '\tuseZBuffer  1\n', '\tcreaseAngle 80\n', '\tchannels\n', '\t\t{\n', '\t\t}\n',
                 '\tendPoint 0 0 0\n', '\torigin 0 0 0\n', '\torientation 0 0 0\n', '\tdisplayOrigin  0\n', '\tdisplayMode USEPARENT\n',
                 '\tcustomMaterial 0\n', '\tlocked 0\n', '\tbackfaceCull 0\n', '\tvisibleInReflections 1\n', '\tvisibleInRender 1\n',
                 '\tvisibleInCamera 1\n', '\t}\n', 'light spotLight 1\n', '\t{\n', '\tstorageOffset 0 0 0\n',
                 '\tobjFileGeom 0 0 :Runtime:Geometries:Lights:infLite.obj\n', '\tlightType 0\n', '\tname    LIGHT1\n', '\toff\n',
                 '\tbend 1\n', '\tdynamicsLock  1\n', '\thidden  0\n', '\taddToMenu 1\n', '\tcastsShadow  1\n', '\tincludeInDepthCue  1\n',
                 '\tuseZBuffer  1\n', '\tparent UNIVERSE\n', '\tcreaseAngle 80\n', '\tchannels\n', '\t\t{\n', '\t\tliteFalloffStart Angle Start\n',
                 '\t\t\t{\n', '\t\t\tname Angle Start\n', '\t\t\tinitValue 0\n', '\t\t\thidden 1\n', '\t\t\tforceLimits 1\n', '\t\t\tmin 0\n',
                 '\t\t\tmax 160\n', '\t\t\ttrackingScale 0.25\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  0\n',
                 '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\tliteFalloffEnd Angle End\n',
                 '\t\t\t{\n', '\t\t\tname Angle End\n', '\t\t\tinitValue 70\n', '\t\t\thidden 1\n', '\t\t\tforceLimits 1\n', '\t\t\tmin 0\n', '\t\t\tmax 160\n',
                 '\t\t\ttrackingScale 0.25\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  70\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n',
                 '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\tliteAttenStart Dist Start\n', '\t\t\t{\n',
                 '\t\t\tname Dist Start\n', '\t\t\tinitValue 0\n', '\t\t\thidden 1\n', '\t\t\tforceLimits 1\n', '\t\t\tmin 0\n', '\t\t\tmax 1e+006\n',
                 '\t\t\ttrackingScale 0.01\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  0\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n',
                 '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\tliteAttenEnd Dist End\n', '\t\t\t{\n', '\t\t\tname Dist End\n',
                 '\t\t\tinitValue 0\n', '\t\t\thidden 1\n', '\t\t\tforceLimits 1\n', '\t\t\tmin 0\n', '\t\t\tmax 1e+006\n', '\t\t\ttrackingScale 0.01\n',
                 '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  0\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n',
                 '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\tdepthMapStrength shadowStrength\n', '\t\t\t{\n', '\t\t\tname Shadow\n', '\t\t\tinitValue 1\n',
                 '\t\t\thidden 0\n', '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 0.01\n', '\t\t\tkeys\n',
                 '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  1\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n',
                 '\t\t\t}\n', '\t\tdepthMapSize depthMapSize\n', '\t\t\t{\n', '\t\t\tname Map Size\n', '\t\t\tinitValue 256\n', '\t\t\thidden 0\n',
                 '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 1\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n',
                 '\t\t\t\tk  0  256\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\trotateX xrot\n',
                 '\t\t\t{\n', '\t\t\tname xrot\n', '\t\t\tinitValue -42\n', '\t\t\thidden 0\n', '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n',
                 '\t\t\ttrackingScale 1\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  -24.1343\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n',
                 '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\trotateY yrot\n', '\t\t\t{\n', '\t\t\tname yrot\n',
                 '\t\t\tinitValue -90.347\n', '\t\t\thidden 0\n', '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 1\n',
                 '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  -20.8689\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n',
                 '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\trotateZ zrot\n', '\t\t\t{\n', '\t\t\tname zrot\n', '\t\t\tinitValue 0\n', '\t\t\thidden 0\n',
                 '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 1\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n',
                 '\t\t\t\tk  0  3.21412\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n',
                 '\t\tscale scale\n', '\t\t\t{\n', '\t\t\tname scale\n', '\t\t\tinitValue 0.55\n', '\t\t\thidden 0\n', '\t\t\tforceLimits 0\n', '\t\t\tmin 0.001\n',
                 '\t\t\tmax 100000\n', '\t\t\ttrackingScale 0.004\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  0.55\n', '\t\t\t\tsl  1\n',
                 '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\tkdRed KdRed\n', '\t\t\t{\n', '\t\t\tname RED\n',
                 '\t\t\tinitValue 1\n', '\t\t\thidden 0\n', '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 0.004\n',
                 '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  1\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n',
                 '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\tkdGreen KdGreen\n', '\t\t\t{\n', '\t\t\tname GREEN\n', '\t\t\tinitValue 1\n', '\t\t\thidden 0\n',
                 '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 0.004\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n',
                 '\t\t\t\tk  0  1\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\tkdBlue KdBlue\n',
                 '\t\t\t{\n', '\t\t\tname BLUE\n', '\t\t\tinitValue 1\n', '\t\t\thidden 0\n', '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n',
                 '\t\t\ttrackingScale 0.004\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  1\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n',
                 '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\tkdIntensity KdIntensity\n', '\t\t\t{\n', '\t\t\tname INTENSITY\n',
                 '\t\t\tinitValue 1\n', '\t\t\thidden 0\n', '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 0.004\n',
                 '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  1\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n',
                 '\t\t\tinterpStyleLocked 0\n', '\t\t\t}\n', '\t\ttranslateX xtran\n', '\t\t\t{\n', '\t\t\tname xtran\n', '\t\t\tinitValue 0\n', '\t\t\thidden 1\n',
                 '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 0.001\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n',
                 '\t\t\t\tk  0  0\n', '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\ttrackingScaleMult 1\n',
                 '\t\t\t}\n', '\t\ttranslateY ytran\n', '\t\t\t{\n', '\t\t\tname ytran\n', '\t\t\tinitValue 0.375\n', '\t\t\thidden 1\n', '\t\t\tforceLimits 0\n',
                 '\t\t\tmin -100000\n', '\t\t\tmax 100000\n', '\t\t\ttrackingScale 0.001\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  0.375\n',
                 '\t\t\t\tsl  1\n', '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\ttrackingScaleMult 1.000000\n', '\t\t\t}\n',
                 '\t\ttranslateZ ztran\n', '\t\t\t{\n', '\t\t\tname ztran\n', '\t\t\tinitValue -100\n', '\t\t\thidden 1\n', '\t\t\tforceLimits 0\n', '\t\t\tmin -100000\n',
                 '\t\t\tmax 100000\n', '\t\t\ttrackingScale 0.001\n', '\t\t\tkeys\n', '\t\t\t\t{\n', '\t\t\t\tstatic  0\n', '\t\t\t\tk  0  -100\n', '\t\t\t\tsl  1\n',
                 '\t\t\t\tspl\n', '\t\t\t\tsm\n', '\t\t\t\t}\n', '\t\t\tinterpStyleLocked 0\n', '\t\t\ttrackingScaleMult 1.000000\n', '\t\t\t}\n', '\t\t}\n',
                 '\tendPoint 0 0 0.07\n', '\torigin 0 0 0\n', '\torientation 0 0 0\n', '\tdisplayOrigin  0\n', '\tdisplayMode EDGESONLY\n', '\tcustomMaterial 0\n',
                 '\tlocked 0\n', '\tbackfaceCull 0\n', '\tvisibleInReflections 1\n', '\tvisibleInRender 1\n', '\tvisibleInCamera 1\n', '\tdisplacementBounds 0\n',
                 '\tshadingRate 0.2\n', '\tsmoothPolys 1\n', '\tdepthMapSize 256\n', '\tpreviewDepthMapSize 512\n', '\tdepthCamera SHADOW_CAM_LITE 5\n', '\tdoShadow 1\n',
                 '\tlightOn 1\n', '\trayTraceShadows 0\n', '\tdepthMapShadows 1\n', '\tshadowBlurRadius 2\n', '\tshadowRaytraceSoftness 0.000000\n', '\tshadowSamples 19\n',
                 '\tshadowBiasMin 0.800000\n', '\tatmosphereStrength 0.010000\n', '\tincludeInOpenGL 1\n', '\tdoAmbientOc 0\n', '\tambientOcDist 0.058135\n',
                 '\tambientOcBias 0.000900\n', '\tambientOcStrength 0.700000\n', '\tattenType 0\n', '\t}\n', 'doc\n', '\t{\n', '\tdisplayMode TEXTURESHADED\n',
                 '\tuseLimits  0\n', '\theadGuides  0\n', '\thorizon  0\n', '\tvanishingLines 0\n', '\tdrawBackfacing 0\n', '\thipShoulder  0\n', '\tgroundDisplay  0\n',
                 '\tdepthCue  0\n', '\tboxesAlways  0\n', '\tbgPicOn  0\n', '\thandLockOn 0\n', '\tloopInterpolation  0\n', '\tquatInterpolation  0\n', '\tdoBalance  0\n',
                 '\tfastTracking  0\n', '\tgroundShadows  0\n', '\tbendBodies  1\n', '\tfgColor  0.0117037 0.0117037 0.0117037\n', '\tbgColor  0.549981 0.519524 0.499962\n',
                 '\tshadowColor  0.449989 0.429984 0.409995\n', '\tpaperTexture -1\n', '\taddActor GROUND\n', '\taddActor UNIVERSE\n', '\taddLight spotLight 1\n',
                 '\trootActor UNIVERSE\n', '\tproductionFrame 1\n', '\t}\n', 'setGeomHandlerOffset 0 0.3487 0\n', '}\n']
    poser_temp = poser.TempLocation()    
    path_temp = os.path.normpath(os.path.join(poser_temp,"temp_scene.pz3"))
    f = open(path_temp,"w")
    for line in scenelist:
        f.write(line)
    f.close()
    return path_temp

def PP_script_logo1():
    """
    """
    #	Logo Embedding
    jpg1_b64 = \
    """iVBORw0KGgoAAAANSUhEUgAAAVYAAAA1BAMAAADolt7wAAAAB3RJTUUH3AIHFDMp48nr3QAAAAlw
    SFlzAAALEgAACxIB0t1+/AAAAARnQU1BAACxjwv8YQUAAAAnUExURUlJSYeHh7i4uOfn5/7+/j4+
    PtbW1lRUVKOjo3Z2dmlpaczMzJeXl7IKd00AAAWJSURBVHja1ZrPbxtFFMdn7W2w1z44IkKB9rDQ
    RQoKBxuvUBA9rL2vi2PnACVLG7iExgRErqBejeKiSORgEoOUnoxIhVouhlioEA6WakVI9I/iza/9
    YW8cOwg2+UqxZ3Zndj/z5s17s+sQEiFl8Xhr8WVyGbRnOgvXvrbvtuIGOVsv2K/Rr/SR048b5Sxl
    bIl4UmzEDTNeWrHvlfeKnbhxxmpfD1QyVtw446T9EqpuxM0zTunw4ldLyvyRXXwrbqyJdPz21itf
    zV5o8/p6iX6046aYQpeJtRk3wBRaihtgcqWtuAmmUL0cN8EUenoJ9lxSyUbcBJMr48RNMIX2G3ET
    TK7EetwEU7Dm4yaYXBr040aYXNmhEJsFJvHA880x6tccLaYXafkJlpqQk60BpyVl8i7LROUFvKJy
    7OmJbFFrsC4n7Kh+Lti5sGETINTBiiHKfToBXBg4et5caGCRlOxQkqxQ8a+CksMHNsSBKHfPwzqz
    Hs1q4Snwbk7a/vEwa3OUFRoh1kAL//L2uVjDI/TM5Pg2AGgR8I+HWNMQwVoNsmp+MTBkaJyDVQ37
    gLb7jGpAL4yj30T1AHS8uUPL6HmtECueqLAezxokxQt1qCi/sba0y11ssUQPNykf9qenjti8Ta2j
    yKMKOqkCYhH1wFLFpKEZGyHW5OhsykOHkBfVKy4V5QO4z8pzuBSnVna4j+ddaEuRgQ8pq7CDAd0Q
    qwor/gBNf7IJne88711ieG4bLBw+L78f6Da5C+jh+pznUPqMvJ4aYB2MsFa9vj2IYsUWnG8VrBTU
    ePkWXa/TyghXAwthUlZvYjIwOetHQ6xZHpeHRSPRDZLh99NEl6w1cr+pWdtTsH4x5APoPkUYzfcJ
    sIugi7lPCATVkvez+XoyAqyDAKsJ+mmsJlR+uodSxrJqj1GP6gHX4SA33TsRhlVfdT+wBKvcbMvs
    NZBMTZ8V135esmIA6p/GKtf4h2NZ5YIYMmLmHfd2LYJVd9ckq3zqlm47kMmPs6ZoTK0jH7LOiPhK
    TmflsWltLKvM20NPTxnLfa9Mnto6umGBZOtLZPuNbYfa9RZlHaDNe0atle6VSXoGPuasepBVZiLq
    ssIgK8iaC7JWfVZ3LKvKWJtevg37QOWgWU1B3SHmZpkMHOhiOnqzo5Z+MPLIetXskp5d77YdM89a
    jNpVsC4HWHVkbQRZSz7rl9Gsy5z1kLHyxO0MP5TSrNw6rL5r9Gln58qdFVLv0s4Y5JE1vV0iZl9p
    wcO1MhHZZ07emrPyvG63KOuh3MYYninDeQvgkyhWL2+ZkEfWJF6kMDvy/JyoLORI8zt3dd20dQU2
    N2xSpwO98XqOsppQIw5dOptbQMDWuRFgYQfVEmvrW1rJsbClzWJxlzHADlNfo5aCz3itYYBDv3e1
    MCvdD9Dj25iekZVmjIicxV5fGw/dVStRBIwk2NAkIlWpeqJ8lbEqbIeWMG05FVTrgTjAx2B5ZW+r
    WNVYhpf7LOncj8OswX0WZaU7uUI06+C+29bpQneeu9cJsqo3b5dZnW2rZSgwz2bVQqzexrGUimYN
    tGCsZB+Ln0eyJsvz0FGuATH+fJFwVrp81MJe7S87N1eeJYMKnlDm+Q2SIvoZp7N6Cao69FxgRLN6
    LfqclbX7Y9hfLW6pEg6tRNi2aUPaNUlzJaygA7SydHkM5KL6m1m28bzdT4H/jj4Zeug4MUU4h3X6
    E58MFunrbImTOg/qP/IlIFvQn9eyLOlTr4Pfh2DZ5KZn8e8AC48eiDlknwd48KDFzqQfiBb/vQ46
    nqUL//JS/5d+FuGPK3V8cVUQ22RH5D+Zdi+iLCL39PzF+vzOxRXzWZGyL8e/CAjYy/FW9XuRduLm
    mEg8SZzrDUwMosnj07ghJpVyvez+A5HOUk6fxWiBAAAAAElFTkSuQmCC
    """
    jpg1 = base64.b64decode(jpg1_b64)
    # End Logo Embed
    return jpg1

class wxGUI(wx.ScrolledWindow):
    def __init__(self,parent):
        wx.ScrolledWindow.__init__(self,parent=parent,id=wx.NewId(),pos=wx.Point(-100,250))
        self.parent = parent

        self.pathDonor = ""
        self.pathTarget = ""
        self.pathBones = ""
        self.status = []
        
        self.libDir = poser.ContentRootLocation() # Start browsing in library for version of Poser which is running the script

        #Call Logo
        jpg1 = PP_script_logo1()
        stream1 = cStringIO.StringIO(jpg1)
        bmp1 = wx.BitmapFromImage(wx.ImageFromStream(stream1))	
        self.logo = wx.StaticBitmap(self, -1, bmp1, (11, 156))   

        #Defines Window base colors
        self.SetBackgroundColour(wx.Colour(74,74,74))
        self.SetForegroundColour(wx.Colour(200,200,200))   	
             

        # Listboxes
        self.labelDonor = wx.StaticText(self, id=-1, label="Figure to have weights injected (.cr2 path)", pos=(60,2), style=wx.ALIGN_CENTER)
        self.listDonor = wx.ListBox(self, id=-1, pos=(60,20), size=(620,20), style=wx.LB_NEEDED_SB)
        self.labelTarget = wx.StaticText(self, id=-1, label="Weight injection pose (.pz2 path)", pos=(60,42), style=wx.ALIGN_CENTER)
        self.listTarget = wx.ListBox(self, id=-1, pos=(60,60), size=(620,20), style=wx.LB_NEEDED_SB)
        self.labelBones = wx.StaticText(self, id=-1, label="Optional pose containing new actors (.pz2 path)", pos=(60,82), style=wx.ALIGN_CENTER)
        self.listBones = wx.ListBox(self, id=-1, pos=(60,100), size=(620,20), style=wx.LB_NEEDED_SB)
        self.printList = wx.ListBox(self, id=-1, pos=(10,215), size=(670,135), style=wx.LB_NEEDED_SB)       

        # Buttons
        self.buttonDonor = wx.Button(self, id=-1, label="...", pos=(10,21), size=(40,18))
        self.Bind(wx.EVT_BUTTON, self.browseDonor, self.buttonDonor)
        self.buttonTarget = wx.Button(self, id=-1, label="...", pos=(10,61), size=(40,18))
        self.Bind(wx.EVT_BUTTON, self.browseTarget, self.buttonTarget)
        self.buttonBones = wx.Button(self, id=-1, label="...", pos=(10,101), size=(40,18))
        self.Bind(wx.EVT_BUTTON, self.browseBones, self.buttonBones)
        self.buttonRun = wx.Button(self, id=-1, label="Run script", pos=(370,175), size=(100,20))
        self.Bind(wx.EVT_BUTTON, self.runScript, self.buttonRun)
        self.buttonQuit = wx.Button(self, id=-1, label="Quit script", pos=(530,175), size=(100,20))
        self.Bind(wx.EVT_BUTTON, self.quitScript, self.buttonQuit)

        # Checkboxes
        self.checkRem = wx.CheckBox(self, id=-1, label="Delete temp files", pos=(10,133))
        self.checkRem.SetValue(1)
        self.checkTemp = wx.CheckBox(self, id=-1, label="Use Poser temp location", pos=(146,133))
        self.checkTemp.SetValue(0)
        self.checkJCM = wx.CheckBox(self, id=-1, label="Remove JCM", pos=(322,133))
        self.checkJCM.SetValue(1)
        self.checkJSM = wx.CheckBox(self, id=-1, label="Remove JSM", pos=(447,133))
        self.checkJSM.SetValue(1)
        self.checkMag = wx.CheckBox(self, id=-1, label="Remove magnets", pos=(567,133))
        self.checkMag.SetValue(1)

        # Tooltips
        self.printList.SetToolTip(wx.ToolTip("Update box showing script progress"))
        self.buttonDonor.SetToolTip(wx.ToolTip("Locate the base character to inject information into"))
        self.buttonRun.SetToolTip(wx.ToolTip("Starts the character creation process\nand loads it into the scene"))
        self.buttonTarget.SetToolTip(wx.ToolTip("Locate the Weight Pose"))
        self.buttonBones.SetToolTip(wx.ToolTip("Locate the additional actors if required"))           
        self.checkTemp.SetToolTip(wx.ToolTip("Compatibility option for write\naccess errors"))        
        self.checkJCM.SetToolTip(wx.ToolTip("Removes all JCMs functions in the character"))        
        self.checkJSM.SetToolTip(wx.ToolTip("Removes all JSMs functions in the character"))                
        self.checkMag.SetToolTip(wx.ToolTip("Removes magnets from the character"))
        self.checkRem.SetToolTip(wx.ToolTip("Removes all temporary files created"))
        self.logo.SetToolTip(wx.ToolTip("Brought to you by the Poser Place Crew!\nhttp://poserplace.phantom3d.net/forums/index.php"))        

        # Gui Color Information
        self.printList.SetBackgroundColour(wx.Colour(90,90,90))
        self.printList.SetForegroundColour(wx.Colour(200,200,200))
        self.listTarget.SetBackgroundColour(wx.Colour(90,90,90))
        self.listTarget.SetForegroundColour(wx.Colour(200,200,200)) 	
        self.listBones.SetBackgroundColour(wx.Colour(90,90,90))
        self.listBones.SetForegroundColour(wx.Colour(200,200,200))
        self.listDonor.SetBackgroundColour(wx.Colour(90,90,90))
        self.listDonor.SetForegroundColour(wx.Colour(200,200,200))        
        ### End GUI

    def status_update(self,line):        
        self.status.append(line)
        self.printList.Append(line)        
        self.printList.SetSelection(len(self.status)-1)
        self.Update()

    def quitScript(self,event):        
        poser.WxAuiManager().DetachPane(self) # This is how you work a "close" button with Poser wxPython
        self.Close(True)
        scene.DrawAll()

    def runScript(self,event):        
        if (not self.pathDonor) or (not self.pathTarget and not self.pathBones):
            print "This script requires that the cr2 path and at least one pose path be defined.  Please try again."
            return
        load_cr2(self.pathDonor,self.pathTarget,self.pathBones,remove_files=self.checkRem.GetValue(),write_to_temp=self.checkTemp.GetValue(),
                 remove_JCM=self.checkJCM.GetValue(),remove_JSM=self.checkJSM.GetValue(),remove_mags=self.checkMag.GetValue())        
        scene.DrawAll()

    def browseDonor(self,event):       
        dialog = wx.FileDialog(None, message="Locate target .cr2", wildcard="Poser Character File|*.cr2;*.crz;*.CR2;*.CRZ", defaultDir=self.libDir, style=wx.OPEN)
        if dialog.ShowModal() == wx.ID_OK:
            p = dialog.GetPath()
        else:
            return
        self.listDonor.InsertItems([p],0)
        self.pathDonor = p
        self.libDir = dialog.GetDirectory()

    def browseTarget(self,event):       
        dialog = wx.FileDialog(None, message="Locate weight pose", wildcard="Poser Pose File|*.pz2;*.p2z;*.PZ2;*.P2Z", defaultDir=self.libDir, style=wx.OPEN)
        if dialog.ShowModal() == wx.ID_OK:
            p = dialog.GetPath()
        else:
            return
        self.listTarget.InsertItems([p],0)
        self.pathTarget = p
        self.libDir = dialog.GetDirectory()
        
    def browseBones(self,event):        
        dialog = wx.FileDialog(None, message="Locate actors pose", wildcard="Poser Pose File|*.pz2;*.p2z;*.PZ2;*.P2Z", defaultDir=self.libDir, style=wx.OPEN)
        if dialog.ShowModal() == wx.ID_OK:
            p = dialog.GetPath()
        else:
            return
        self.listBones.InsertItems([p],0)
        self.pathBones = p
        self.libDir = dialog.GetDirectory()

app = wxGUI(root)
man.AddPane(app, wx.aui.AuiPaneInfo().
            Caption("Weight Pose Applicator 6g").CaptionVisible().
            Float().Resizable().DestroyOnClose().Dockable(False).
            FloatingSize(wx.Size(706, 400)).CloseButton(True))
info = man.GetPane(app)
info.Show()
man.Update()
